package test;

import junit.framework.TestCase;

/**
 * Provided specialized methods for testing POBS parsers.
 * @author	Martijn W. van der Lee
 */
public abstract class TestCaseParser extends TestCase {
    public TestCaseParser() {
        super();
    }

    public TestCaseParser(String arg0) {
        super(arg0);
    }

    public void assertMatch(
        java.lang.String message,
        pobs.PMatch match,
        long length) {

        assertTrue(message + ", match", match.isMatch());
        assertEquals(message + ", length", match.getLength(), length);
    }

    public void assertMismatch(
        java.lang.String message,
        pobs.PMatch match,
        long length) {

        assertFalse(message + ", match", match.isMatch());
        assertEquals(message + ", length", match.getLength(), length);
    }

    final public pobs.PMatch parse(
        pobs.PObject parser,
        java.lang.String input,
        long begin) {
        return parser.process(
            new pobs.scanner.PStringScanner(input),
            begin,
            new pobs.PContext());
    }

    final public pobs.PMatch parse(
        pobs.PObject parser,
        java.lang.String input) {
        return parse(parser, input, 0);
    }
}